[PATCH 3/5] erofs-utils: tests: add test for xattrs in different layouts

Jingbo Xu jefflexu at linux.alibaba.com
Thu May 25 18:31:59 AEST 2023


Test extended attributes in following layouts:

- multiple inline xattrs for one single file
- multiple share xattrs for one single file
- mixed inline and share xattrs for one single file

Signed-off-by: Jingbo Xu <jefflexu at linux.alibaba.com>
---
 tests/Makefile.am   |  3 +++
 tests/erofs/020     | 77 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/erofs/020.out |  2 ++
 3 files changed, 82 insertions(+)
 create mode 100755 tests/erofs/020
 create mode 100644 tests/erofs/020.out

diff --git a/tests/Makefile.am b/tests/Makefile.am
index b85ae89..1d6ea5c 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -91,6 +91,9 @@ TESTS += erofs/018
 # 019 - check extended attribute functionality
 TESTS += erofs/019
 
+# 020 - check extended attributes in different layouts
+TESTS += erofs/020
+
 EXTRA_DIST = common/rc erofs
 
 clean-local: clean-local-check
diff --git a/tests/erofs/020 b/tests/erofs/020
new file mode 100755
index 0000000..5f98be2
--- /dev/null
+++ b/tests/erofs/020
@@ -0,0 +1,77 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0+
+#
+# 020 - check extended attributes in different layouts
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$(echo $0 | awk '{print $((NF-1))"/"$NF}' FS="/")
+
+# get standard environment, filters and checks
+. "${srcdir}/common/rc"
+
+cleanup()
+{
+	cd /
+	rm -rf $tmp.*
+}
+
+_require_erofs
+_require_xattr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+echo "QA output created by $seq"
+
+if [ -z $SCRATCH_DEV ]; then
+	SCRATCH_DEV=$tmp/erofs_$seq.img
+	rm -f SCRATCH_DEV
+fi
+
+localdir="$tmp/$seq"
+rm -rf $localdir
+mkdir -p $localdir
+
+# set random xattrs
+
+# preapre key/value of shared xattrs
+s_key_1=$(_srandom)
+s_key_2=$(_srandom)
+s_val=$(_srandom)
+
+# file1: one inline xattr
+touch $localdir/file1
+setfattr -n user.p$(_srandom) -v $(_srandom) $localdir/file1
+
+# file2: one share xattr
+touch $localdir/file2
+setfattr -n user.s$s_key_1 -v $s_val $localdir/file2
+
+# file3: multiple inline xattrs
+touch $localdir/file3
+setfattr -n user.p$(_srandom) -v $(_srandom) $localdir/file3
+setfattr -n user.p$(_srandom) -v $(_srandom) $localdir/file3
+
+# file4: multiple share xattrs
+touch $localdir/file4
+setfattr -n user.s$s_key_1 -v $s_val $localdir/file4
+setfattr -n user.s$s_key_2 -v $s_val $localdir/file4
+
+# file5: mixed inline and share xattrs
+touch $localdir/file5
+setfattr -n user.p$(_srandom) -v $(_srandom) $localdir/file5
+setfattr -n user.s$s_key_1 -v $s_val $localdir/file5
+
+MKFS_OPTIONS="$MKFS_OPTIONS -x1"
+_scratch_mkfs $localdir >> $seqres.full 2>&1 || _fail "failed to mkfs"
+_scratch_mount 2>>$seqres.full
+
+# check xattrs
+_check_xattrs $localdir $SCRATCH_MNT
+
+_scratch_unmount
+
+echo Silence is golden
+status=0
+exit 0
diff --git a/tests/erofs/020.out b/tests/erofs/020.out
new file mode 100644
index 0000000..20d7944
--- /dev/null
+++ b/tests/erofs/020.out
@@ -0,0 +1,2 @@
+QA output created by 020
+Silence is golden
-- 
1.8.3.1



More information about the Linux-erofs mailing list